package u5a2;

import list.List;
import org.junit.Test;

public class Tests extends list.Tests {
	private void checkAppend(List list, int value, String expected)
	{
		MutableLists.append(list, value);
		check(list, expected);
	}
	
	@Test
	public void append()
	{
		checkAppend(create(1), 2, "1, 2, null");
		checkAppend(create(1,2), 3, "2, 1, 3, null");
	}
	
	private void checkConcat(List first, List second, String expected)
	{
		MutableLists.concat(first, second);
		check(first, expected);
	}
	
	@Test
	public void concat()
	{
		checkConcat(create(1), null, "1, null");
		checkConcat(create(1,2), null, "2, 1, null");
		checkConcat(create(1), create(2), "1, 2, null");
		checkConcat(create(1,2), create(3,4), "2, 1, 4, 3, null");
	}
	
	@Test(expected = IndexOutOfBoundsException.class)
	public void insertAtFail1()
	{
		MutableLists.insertAt(null, 0, 0);
	}
	
	@Test(expected = IndexOutOfBoundsException.class)
	public void insertAtFail2()
	{
		MutableLists.insertAt(create(1), 1, 0);
	}
	
	@Test(expected = IndexOutOfBoundsException.class)
	public void insertAtFail3()
	{
		MutableLists.insertAt(create(1,2), 2, 0);
	}
	
	private void checkInsertAt(List list, int index, int value, String expected)
	{
		MutableLists.insertAt(list, index, value);
		check(list, expected);
	}
	
	@Test
	public void insertAt()
	{
		checkInsertAt(create(1), 0, 2, "1, 2, null");
		checkInsertAt(create(1,2), 1, 3, "2, 1, 3, null");
		checkInsertAt(create(1,2,3), 2, 4, "3, 2, 1, 4, null");
		checkInsertAt(create(1,2,3), 1, 4, "3, 2, 4, 1, null");
	}
	
	@Test(expected = IndexOutOfBoundsException.class)
	public void removeFail1()
	{
		MutableLists.remove(null, 0);		
	}
	
	@Test(expected = IndexOutOfBoundsException.class)
	public void removeFail2()
	{
		MutableLists.remove(create(1), 1);		
	}

	@Test(expected = IndexOutOfBoundsException.class)
	public void removeFail3()
	{
		MutableLists.remove(create(1,2), 2);		
	}
	
	private void checkRemove(List list, int position, String expected)
	{
		check(MutableLists.remove(list, position), expected);
	}
	
	@Test
	public void remove()
	{
		checkRemove(create(1), 0, "null");
		checkRemove(create(1,2), 0, "1, null");
		checkRemove(create(1,2), 1, "2, null");
		checkRemove(create(1,2,3), 1, "3, 1, null");
	}
}
